#
# If you wan to use this file, all obj files must be in "OBJS".
#
DDEPS           :=  $(patsubst %.o,%.d, $(OBJS))    # all ".d" files we should have
MISSING_DDEPS   :=  $(filter-out $(wildcard $(DDEPS)), $(DDEPS))

CFLAGS += -Wall
all:$(TARGET)
	
$(TARGET):$(OBJS)
	$(CC) -shared -Wl,-soname,$(TARGET).0 -o $(TARGET).0.0 $(OBJS) $(D_OBJS)
	$(STRIP) $(TARGET).0.0
	ln -sf $(TARGET).0.0 $(TARGET).0
	ln -sf $(TARGET).0 $(TARGET)
	cp -f *.h $(COMM_INC_PATH)	

%.o: %.c
	echo $@; $(CC) $(CFLAGS) -I$(COMM_INC_PATH) -o $@ -c $<

romfs:
	cp -afv $(TARGET)* $(T_LIB)
clean:
	-rm -f *.[aod] 

ifneq ($(MISSING_DDEPS),)
$(MISSING_DDEPS):
	rm -f $(patsubst %.d, %.o,$@)
endif
-include $(DDEPS)


