/*
This file is for get realtek log content,normally you don't need it!
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rtl_types.h>
#include <rtl8651_tblDrv.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "get_log.h"
#include "board.h"

extern int  rtl865x_kmmap(int base,int length);
extern romeCfgParam_t *pRomeCfgParam;
extern uint32 __crmr_addr;
extern uint32 __flash_base;

struct circ_buf *bufLog;

struct circ_buf *getCircBufPtrByModuleId(int moduleId)
{
	int tmp_moduleId = moduleId;
	int idx = 0,i;
	uint32 ptr;
	int shmid;
	FILE *f;
	struct circ_buf *buf=NULL;

	while (tmp_moduleId>1)
	{
		idx ++;
		tmp_moduleId = tmp_moduleId >> 1;
	}

	switch(moduleId)
	{
		case RTL8651_LOGMODULE_SYS:
			if ((shmid = shmget(0x414e4547, 16000+sizeof(struct circ_buf), IPC_CREAT | 0666)) == -1) {
				printf("line:%d", __LINE__);
				return -1;
			}
			if ((buf = shmat(shmid, NULL, 0)) == NULL) {
				printf("line:%d", __LINE__);
				return -1;
	        }				
			break;
			
		case RTL8651_LOGMODULE_ACL:
		case RTL8651_LOGMODULE_DOS:
		case RTL8651_LOGMODULE_URL:
		case RTL8651_LOGMODULE_NEWFLOW:
			f = fopen("/proc/log_module","r");
			if(f==NULL){
				printf("line:%d", __LINE__);
			 return -1;
			}
			for(i=0;i<idx;i++)
				fscanf(f,"%x",&ptr);
			fscanf(f,"%x",&ptr);
			fclose(f);
			if(ptr==0)
			{ 
				printf("line:%d", __LINE__);
				return -1;
			}
#ifdef __uClinux__
			buf=ptr;	
#else		
			buf=rtl865x_kmmap(ptr-0x80000000,sizeof(struct circ_buf)+16000);
#endif					
			break;	
	}
	return buf;
}
void get_rtl_log(void)
{
    FILE *fp;
    char **buf1;
    unsigned int moduleId=RTL8651_LOGMODULE_URL;
    int buf_head,size,tail,i,j;
    int show=0;
    unsigned char ms =0;
    
    fp = fopen(LOG_MESSAGE,"w");
    if(!fp)
        printf("fopen log message file error\n");
        
    *buf1=malloc(LOG_SIZE);
	if(*buf1==NULL)
	{
		printf("**buf1 == NULL");
		return;
	}
	memset(*buf1,0,LOG_SIZE);    
	
    bufLog=(struct circ_buf *)getCircBufPtrByModuleId(moduleId);    
    if(bufLog==-1) 
	{
		printf("bufLog==-1");	
		return;
	}
	
	buf_head=bufLog->head;
	size=bufLog->size;
	tail=bufLog->tail;
		
	if(buf_head>tail) 
	    tail+=size;

	if(bufLog->data[buf_head]==(ms+'0')) 
	    show=1;
	if(moduleId!=RTL8651_LOGMODULE_SYS) 
	    buf_head++;
	    
	//printf("bufLog of log: buf_head=%d, tail=%d, size=%d, show=%d", buf_head, tail, size, show);
	
	for(j=0, i=buf_head;i<tail;i++)
	{
		int idx=i;
		while(idx>=size) 
		    idx-=size;
		if( j>= 1024 )
			break;
			
		if(bufLog->data[idx]==10) 
		{ 
			if(show==1||moduleId==RTL8651_LOGMODULE_SYS) 
			{
				/*printf("next line");
				(*buf1)[j++] = '<';
				(*buf1)[j++] = 'b';
				(*buf1)[j++] = 'r';
				(*buf1)[j++] = '>';
				/printf("skip to next");
				*/
				(*buf1)[j++] = '\n';
			}
			continue;
		}	
		if(bufLog->data[idx]==0) 
		{
			if(bufLog->data[(idx+1)%size]==(ms+'0')) 
			    show=1;
			else 
			    show=0;
			if(moduleId!=RTL8651_LOGMODULE_SYS) 
			    i++;
			continue;						
		}
		if(show==1||moduleId==RTL8651_LOGMODULE_SYS) 
		{
			(*buf1)[j++] = bufLog->data[idx];
		}
		
	}
	//strcpy(buf, *buf1);
	fprintf(fp, "%s", *buf1);
	fclose(fp);
	free(*buf1);
}

